Tesseract 3.02

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- File List
- File Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Groups Pages
Macros | Enumerations | Functions | Variables
picofeat.h File Reference
`#include "ocrfeatures.h"`
`#include "params.h"`

Go to the source code of this file.

## Macros

#define | MAX_PICO_FEATURES (1000)
#define | GetPicoFeatureLength() (PicoFeatureLength)

## Enumerations

enum | IntParams { IntX, IntY, IntDir }
enum | GeoParams { GeoBottom, GeoTop, GeoWidth, GeoCount }
enum | PICO_FEAT_PARAM_NAME { PicoFeatY, PicoFeatDir, PicoFeatX }

## Functions

FEATURE_SET | ExtractIntCNFeatures (TBLOB *Blob, const DENORM &denorm)
FEATURE_SET | ExtractIntGeoFeatures (TBLOB *Blob, const DENORM &denorm)

## Variables

double | classify_pico_feature_length = 0.05
FLOAT32 | PicoFeatureLength

## Macro Definition Documentation

#define GetPicoFeatureLength | ( |  | ) | (PicoFeatureLength)

Public Function Prototypes —————————————————————————-

Definition at line 59 of file picofeat.h.

#define MAX_PICO_FEATURES (1000)

Definition at line 47 of file picofeat.h.

## Enumeration Type Documentation

enum GeoParams

Enumerator:

  GeoBottom |
  GeoTop |
  GeoWidth |
  GeoCount |

Definition at line 35 of file picofeat.h.

{
GeoBottom, // Bounding box bottom in baseline space (0-255).
GeoTop, // Bounding box top in baseline space (0-255).
GeoWidth, // Bounding box width in baseline space (0-255).
GeoCount // Number of geo features.
};

enum IntParams

Include Files and Type Defines —————————————————————————-

Enumerator:

  IntX |
  IntY |
  IntDir |

Definition at line 28 of file picofeat.h.

{
IntX, // x-position (0-255).
IntY, // y-position (0-255).
IntDir // Direction (0-255, circular).
};

enum PICO_FEAT_PARAM_NAME

Enumerator:

  PicoFeatY |
  PicoFeatDir |
  PicoFeatX |

Definition at line 43 of file picofeat.h.

{ PicoFeatY, PicoFeatDir, PicoFeatX }

## Function Documentation

FEATURE_SET ExtractIntCNFeatures | ( | TBLOB * | Blob,
|  | const DENORM & | denorm
| ) |  |

Definition at line 227 of file picofeat.cpp.

{
/*
** Parameters:
** blob blob to extract features from
** denorm normalization/denormalization parameters.
** Return: Integer character-normalized features for blob.
** Exceptions: none
** History: 8/8/2011, rays, Created.
*/
tesseract::TrainingSample* sample = GetIntFeatures(
tesseract::NM_CHAR_ANISOTROPIC, blob, denorm);
if (sample == NULL) return NULL;
int num_features = sample->num_features();
const INT_FEATURE_STRUCT* features = sample->features();
FEATURE_SET feature_set = NewFeatureSet(num_features);
for (int f = 0; f < num_features; ++f) {
FEATURE feature = NewFeature(&IntFeatDesc);
feature->Params[IntX] = features[f].X;
feature->Params[IntY] = features[f].Y;
feature->Params[IntDir] = features[f].Theta;
AddFeature(feature_set, feature);
}
delete sample;
return feature_set;
} /* ExtractIntCNFeatures */

FEATURE_SET ExtractIntGeoFeatures | ( | TBLOB * | Blob,
|  | const DENORM & | denorm
| ) |  |

Definition at line 257 of file picofeat.cpp.

{
/*
** Parameters:
** blob blob to extract features from
** denorm normalization/denormalization parameters.
** Return: Geometric (top/bottom/width) features for blob.
** Exceptions: none
** History: 8/8/2011, rays, Created.
*/
tesseract::TrainingSample* sample = GetIntFeatures(
tesseract::NM_CHAR_ANISOTROPIC, blob, denorm);
if (sample == NULL) return NULL;
FEATURE_SET feature_set = NewFeatureSet(1);
FEATURE feature = NewFeature(&IntFeatDesc);
feature->Params[GeoBottom] = sample->geo_feature(GeoBottom);
feature->Params[GeoTop] = sample->geo_feature(GeoTop);
feature->Params[GeoWidth] = sample->geo_feature(GeoWidth);
AddFeature(feature_set, feature);
delete sample;
return feature_set;
} /* ExtractIntGeoFeatures */

## Variable Documentation

double classify_pico_feature_length = 0.05

"Pico Feature Length"

Include Files and Type Defines —————————————————————————- "Pico Feature Length"

Definition at line 39 of file picofeat.cpp.

FLOAT32 PicoFeatureLength

Global Data Definitions and Declarations —————————————————————————-